/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.50 Revision 1.69
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.50 2007/10/05 13:56:49 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.69 2009/03/24 21:10:13 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 >=media-tv/vdrplugin-rebuild-0.2 77
78 >=app-admin/eselect-vdr-0.0.2 78DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
80 82
83# this is a hack for ebuilds like vdr-xineliboutput that want to
84# conditionally install a vdr-plugin
85if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
86 # make DEPEND conditional
87 IUSE="${IUSE} vdr"
88 DEPEND="vdr? ( ${DEPEND} )"
89 RDEPEND="vdr? ( ${RDEPEND} )"
90fi
81 91
82# New method of storing plugindb 92# New method of storing plugindb
83# Called from src_install 93# Called from src_install
84# file maintained by normal portage-methods 94# file maintained by normal portage-methods
85create_plugindb_file() { 95create_plugindb_file() {
86 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 96 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
87 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}" 97 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
88 insinto "${NEW_VDRPLUGINDB_DIR}" 98 insinto "${NEW_VDRPLUGINDB_DIR}"
99
100# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
89 cat <<-EOT > "${D}/${DB_FILE}" 101# cat <<-EOT > "${D}/${DB_FILE}"
90 VDRPLUGIN_DB=1 102# VDRPLUGIN_DB=1
91 CREATOR=ECLASS 103# CREATOR=ECLASS
92 EBUILD=${CATEGORY}/${PN} 104# EBUILD=${CATEGORY}/${PN}
93 EBUILD_V=${PVR} 105# EBUILD_V=${PVR}
94 EOT 106# EOT
107 {
108 echo "VDRPLUGIN_DB=1"
109 echo "CREATOR=ECLASS"
110 echo "EBUILD=${CATEGORY}/${PN}"
111 echo "EBUILD_V=${PVR}"
112 echo "PLUGINS=\"$@\""
113 } > "${D}/${DB_FILE}"
95} 114}
96 115
97# Delete files created outside of vdr-plugin.eclass 116# Delete files created outside of vdr-plugin.eclass
98# vdrplugin-rebuild.ebuild converted plugindb and files are 117# vdrplugin-rebuild.ebuild converted plugindb and files are
99# not deleted by portage itself - should only be needed as 118# not deleted by portage itself - should only be needed as
100# long as not every system has switched over to 119# long as not every system has switched over to
101# vdrplugin-rebuild-0.2 120# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
102delete_orphan_plugindb_file() { 121delete_orphan_plugindb_file() {
103 #elog Testing for orphaned plugindb file 122 #elog Testing for orphaned plugindb file
104 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 123 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
105 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}" 124 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
106 125
122create_header_checksum_file() 141create_header_checksum_file()
123{ 142{
124 # Danger: Not using $ROOT here, as compile will also not use it !!! 143 # Danger: Not using $ROOT here, as compile will also not use it !!!
125 # If vdr in $ROOT and / differ, plugins will not run anyway 144 # If vdr in $ROOT and / differ, plugins will not run anyway
126 145
146 local CHKSUM="header-md5-vdr"
147
148 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
149 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
150 elif type -p md5sum >/dev/null 2>&1; then
151 (
152 cd "${VDR_INCLUDE_DIR}"
153 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
154 ) > "${CHKSUM}"
155 else
156 die "Could not create md5 checksum of headers"
157 fi
158
127 insinto "${VDR_CHECKSUM_DIR}" 159 insinto "${VDR_CHECKSUM_DIR}"
128 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 160 local p_name
129 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}" 161 for p_name; do
162 newins "${CHKSUM}" "header-md5-${p_name}"
163 done
164}
165
166fix_vdr_libsi_include()
167{
168 einfo "Fixing include of libsi-headers"
169 local f
170 for f; do
171 sed -i "${f}" \
172 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
173 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
174 done
175}
176
177vdr_patchmakefile() {
178 einfo "Patching Makefile"
179 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
180 cp Makefile "${WORKDIR}"/Makefile.before
181
182 # plugin makefiles use VDRDIR in strange ways
183 # assumptions:
184 # 1. $(VDRDIR) contains Make.config
185 # 2. $(VDRDIR) contains config.h
186 # 3. $(VDRDIR)/include/vdr contains the headers
187 # 4. $(VDRDIR) contains main vdr Makefile
188 # 5. $(VDRDIR)/locale exists
189 # 6. $(VDRDIR) allows to access vdr source files
190 #
191 # We only have one directory (for now /usr/include/vdr),
192 # that contains vdr-headers and Make.config.
193 # To satisfy 1-3 we do this:
194 # Set VDRDIR=/usr/include/vdr
195 # Set VDRINCDIR=/usr/include
196 # Change $(VDRDIR)/include to $(VDRINCDIR)
197
198 ebegin " Setting paths"
199 sed -i Makefile \
200 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
201 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
202 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
203 \
204 -e 's:-I$(DVBDIR)/include::' \
205 -e 's:-I$(DVBDIR)::'
206 eend 0
207
208 # maybe needed for multiproto:
209 #sed -i Makefile \
210 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
211 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
212
213 if ! grep -q APIVERSION Makefile; then
214 ebegin " Converting to APIVERSION"
215 sed -i Makefile \
216 -e 's:^APIVERSION = :APIVERSION ?= :' \
217 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
218 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
219 eend $?
220 fi
221
222 # Correcting Compile-Flags
223 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
224 sed -i Makefile \
225 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
226 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
227
228 # Disabling file stripping, useful for debugging
229 sed -i Makefile \
230 -e '/@.*strip/d' \
231 -e '/strip \$(LIBDIR)\/\$@/d' \
232 -e '/@.*\$(STRIP)/d'
233
234 # Use a file instead of a variable as single-stepping via ebuild
235 # destroys environment.
236 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
237}
238
239vdr_add_local_patch() {
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
241 echo
242 einfo "Applying local patches"
243 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
247}
248
249vdr_has_gettext() {
250 has_version ">=media-video/vdr-1.5.7"
251}
252
253plugin_has_gettext() {
254 [[ -d po ]]
255}
256
257vdr_i18n_convert_to_gettext() {
258 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
259
260 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
261 ewarn "Conversion to gettext disabled in ebuild"
262 return 1
263 fi
264
265 if [[ ! -x ${i18n_tool} ]]; then
266 eerror "Missing ${i18n_tool}"
267 eerror "Please re-emerge vdr"
268 die "Missing ${i18n_tool}"
269 fi
270
271 ebegin "Auto converting translations to gettext"
272 # call i18n-to-gettext tool
273 # take all texts missing tr call into special file
274 "${i18n_tool}" 2>/dev/null \
275 |sed -e '/^"/!d' \
276 -e '/^""$/d' \
277 -e 's/\(.*\)/trNOOP(\1)/' \
278 > dummy-translations-trNOOP.c
279
280 # if there were untranslated texts just run it again
281 # now the missing calls are listed in
282 # dummy-translations-trNOOP.c
283 if [[ -s dummy-translations-trNOOP.c ]]; then
284 "${i18n_tool}" &>/dev/null
285 fi
286
287 # now use the modified Makefile
288 if [[ -f Makefile.new ]]; then
289 mv Makefile.new Makefile
290 eend 0 ""
130 else 291 else
131 if type -p md5sum >/dev/null 2>&1; then 292 eend 1 "Conversion to gettext failed. Plugin needs fixing."
132 cd "${S}" 293 return 1
133 ( 294 fi
134 cd "${VDR_INCLUDE_DIR}" 295}
135 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 296
136 ) > header-md5-${PN} 297vdr_i18n_disable_gettext() {
137 doins header-md5-${PN} 298 ebegin "Disabling gettext support in plugin"
299 # Remove i18n Target if using older vdr
300 sed -i Makefile \
301 -e '/^all:/s/ i18n//'
302 eend 0
303}
304
305vdr_i18n() {
306 if vdr_has_gettext; then
307 einfo "VDR has gettext support"
308 if plugin_has_gettext; then
309 einfo "Plugin has gettext support, fine"
310 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
311 ewarn "Please remove left over NO_GETTEXT_HACK."
312 fi
313 else
314 vdr_i18n_convert_to_gettext
315 if [[ $? != 0 ]]; then
316 eerror ""
317 eerror "Plugin will have only english OSD texts"
318 eerror "it needs manual fixing."
319 fi
138 fi 320 fi
321 else
322 einfo "VDR has no gettext support"
323 if plugin_has_gettext; then
324 vdr_i18n_disable_gettext
139 fi 325 fi
326 fi
140} 327}
328
329vdr-plugin_copy_source_tree() {
330 pushd . >/dev/null
331 cp -r "${S}" "${T}"/source-tree
332 cd "${T}"/source-tree
333 cp "${WORKDIR}"/Makefile.before Makefile
334 # TODO: Fix this, maybe no longer needed
335 sed -i Makefile \
336 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
337 -e 's:^CXXFLAGS:#CXXFLAGS:' \
338 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
339 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
340 popd >/dev/null
341}
342
343vdr-plugin_install_source_tree() {
344 einfo "Installing sources"
345 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
346 insinto "${destdir}-${PV}"
347 doins -r "${T}"/source-tree/*
348
349 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
350}
351
352vdr-plugin_print_enable_command() {
353 local p_name c=0 l=""
354 for p_name in ${vdr_plugin_list}; do
355 c=$(( c+1 ))
356 l="$l ${p_name#vdr-}"
357 done
358
359 elog
360 case $c in
361 1) elog "Installed plugin${l}" ;;
362 *) elog "Installed $c plugins:${l}" ;;
363 esac
364 elog "To activate a plugin execute this command:"
365 elog "\teselect vdr-plugin enable <plugin_name> ..."
366 elog
367}
368
369has_vdr() {
370 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
371}
372
373## exported functions
141 374
142vdr-plugin_pkg_setup() { 375vdr-plugin_pkg_setup() {
143 # -fPIC is needed for shared objects on some platforms (amd64 and others) 376 # -fPIC is needed for shared objects on some platforms (amd64 and others)
144 append-flags -fPIC 377 append-flags -fPIC
145 378
153 386
154 # Pathes to includes 387 # Pathes to includes
155 VDR_INCLUDE_DIR="/usr/include/vdr" 388 VDR_INCLUDE_DIR="/usr/include/vdr"
156 DVB_INCLUDE_DIR="/usr/include" 389 DVB_INCLUDE_DIR="/usr/include"
157 390
158
159 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 391 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
160 LOCDIR="/usr/share/vdr/locale" 392 LOCDIR="/usr/share/vdr/locale"
161 if has_version ">=media-video/vdr-1.5.7"; then 393
162 USE_GETTEXT=1 394 if ! has_vdr; then
395 # set to invalid values to detect abuses
396 VDRVERSION="eclass_no_vdr_installed"
397 APIVERSION="eclass_no_vdr_installed"
398
399 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
400 einfo "VDR not found!"
163 else 401 else
164 USE_GETTEXT=0 402 # if vdr is required
403 die "VDR not found!"
165 fi 404 fi
166 405 return
406 fi
407
167 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 408 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
168 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 409 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
169 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 410 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
170 411
171 einfo "Building ${PF} against vdr-${VDRVERSION}" 412 einfo "Compiling against"
172 einfo "APIVERSION: ${APIVERSION}" 413 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
414}
415
416vdr-plugin_src_util() {
417
418 while [ "$1" ]; do
419
420 case "$1" in
421 all)
422 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
423 ;;
424 prepare|all_but_unpack)
425 vdr-plugin_src_util add_local_patch patchmakefile i18n
426 ;;
427 unpack)
428 base_src_unpack
429 ;;
430 add_local_patch)
431 cd "${S}" || die "Could not change to plugin-source-directory!"
432 vdr_add_local_patch
433 ;;
434 patchmakefile)
435 cd "${S}" || die "Could not change to plugin-source-directory!"
436 vdr_patchmakefile
437 ;;
438 i18n)
439 cd "${S}" || die "Could not change to plugin-source-directory!"
440 vdr_i18n
441 ;;
442 esac
443
444 shift
445 done
173} 446}
174 447
175vdr-plugin_src_unpack() { 448vdr-plugin_src_unpack() {
176 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 449 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
177 eerror "Wrong use of vdr-plugin.eclass." 450 eerror "Wrong use of vdr-plugin.eclass."
178 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 451 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
179 echo 452 echo
180 eerror "Please report this at bugs.gentoo.org." 453 eerror "Please report this at bugs.gentoo.org."
181 die "vdr-plugin_pkg_setup not called!" 454 die "vdr-plugin_pkg_setup not called!"
182 fi 455 fi
183 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 456 if [ -z "$1" ]; then
457 case "${EAPI:-0}" in
458 2)
459 vdr-plugin_src_util unpack
460 ;;
461 *)
462 vdr-plugin_src_util all
463 ;;
464 esac
465
466 else
467 vdr-plugin_src_util $@
468 fi
469}
470
471vdr-plugin_src_prepare() {
472 base_src_prepare
473 vdr-plugin_src_util prepare
474}
475
476vdr-plugin_src_compile() {
477 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
184 478
185 while [ "$1" ]; do 479 while [ "$1" ]; do
186 480
187 case "$1" in 481 case "$1" in
188 all_but_unpack) 482 copy_source)
189 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
190 ;;
191 unpack)
192 base_src_unpack
193 ;;
194 patchmakefile)
195 if ! cd "${S}"; then
196 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
197 ewarn "Perhaps you find one among these:"
198 cd "${WORKDIR}"
199 ewarn "$(/bin/ls -1 "${WORKDIR}")"
200 die "Could not change to plugin-source-directory!"
201 fi
202
203 einfo "Patching Makefile"
204 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
205 cp Makefile "${WORKDIR}"/Makefile.before
206
207 sed -i Makefile \
208 -e '1i\#Makefile was patched by vdr-plugin.eclass'
209
210 ebegin " Setting Pathes"
211 sed -i Makefile \
212 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
213 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
214 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
215 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
216 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
217 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
218 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
219 eend $?
220
221 ebegin " Converting to APIVERSION"
222 sed -i Makefile \
223 -e 's:^APIVERSION = :APIVERSION ?= :' \
224 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
225 -e '2i\APIVERSION = '"${APIVERSION}"
226 eend $?
227
228 ebegin " Correcting Compile-Flags"
229 sed -i Makefile \
230 -e 's:^CXXFLAGS:#CXXFLAGS:' \
231 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
232 eend $?
233
234 ebegin " Disabling file stripping"
235 sed -i Makefile \
236 -e '/@.*strip/d' \
237 -e '/strip \$(LIBDIR)\/\$@/d' \
238 -e '/^STRIP =/d' \
239 -e '/@.*\$(STRIP)/d'
240 eend $?
241
242 # Use a file instead of an variable as single-stepping via ebuild
243 # destroys environment.
244 touch ${WORKDIR}/.vdr-plugin_makefile_patched
245 ;;
246 add_local_patch)
247 cd "${S}"
248 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
249 echo
250 einfo "Applying local patches"
251 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
252 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
253 done
254 fi
255 ;;
256 i18n)
257 cd "${S}"
258 if [[ ${USE_GETTEXT} = 0 ]]; then
259 # Remove i18n Target if using older vdr
260 sed -i Makefile \
261 -e '/^all:/s/ i18n//'
262 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
263 einfo "Converting translations to gettext"
264
265 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
266 if [[ ! -x ${i18n_tool} ]]; then
267 eerror "Missing ${i18n_tool}"
268 eerror "Please re-emerge vdr"
269 die "Missing ${i18n_tool}"
270 fi
271
272 # call i18n-to-gettext tool
273 # take all texts missing tr call into special file
274 "${i18n_tool}" 2>/dev/null \
275 |sed -e '/^"/!d' \
276 -e '/^""$/d' \
277 -e 's/\(.*\)/trNOOP(\1)/' \
278 > dummy-translations-trNOOP.c
279
280 # if there were untranslated texts just run it again
281 # now the missing calls are listed in
282 # dummy-translations-trNOOP.c
283 if [[ -s dummy-translations-trNOOP.c ]]; then
284 "${i18n_tool}" &>/dev/null
285 fi
286
287 # now use the modified Makefile
288 mv Makefile.new Makefile
289 fi
290 esac
291
292 shift
293 done
294}
295
296vdr-plugin_copy_source_tree() {
297 pushd . >/dev/null
298 cp -r "${S}" "${T}"/source-tree
299 cd "${T}"/source-tree
300 cp "${WORKDIR}"/Makefile.before Makefile
301 sed -i Makefile \
302 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
303 -e 's:^CXXFLAGS:#CXXFLAGS:' \
304 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
305 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
306 popd >/dev/null
307}
308
309vdr-plugin_install_source_tree() {
310 einfo "Installing sources"
311 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
312 insinto "${destdir}-${PV}"
313 doins -r "${T}"/source-tree/*
314
315 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
316}
317
318vdr-plugin_src_compile() {
319 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
320
321 while [ "$1" ]; do
322
323 case "$1" in
324 prepare)
325 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 483 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
326 ;; 484 ;;
327 compile) 485 compile)
328 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 486 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
329 eerror "Wrong use of vdr-plugin.eclass." 487 eerror "Wrong use of vdr-plugin.eclass."
333 eerror "Please report this at bugs.gentoo.org." 491 eerror "Please report this at bugs.gentoo.org."
334 die "vdr-plugin_src_unpack not called!" 492 die "vdr-plugin_src_unpack not called!"
335 fi 493 fi
336 cd "${S}" 494 cd "${S}"
337 495
496 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
497
338 emake ${BUILD_PARAMS} \ 498 emake ${BUILD_PARAMS} \
339 ${VDRPLUGIN_MAKE_TARGET:-all} \ 499 ${BUILD_TARGETS} \
340 LOCALEDIR="${TMP_LOCALE_DIR}" \ 500 LOCALEDIR="${TMP_LOCALE_DIR}" \
501 LIBDIR="${S}" \
502 TMPDIR="${T}" \
341 || die "emake failed" 503 || die "emake failed"
342 ;; 504 ;;
343 esac 505 esac
344 506
345 shift 507 shift
366 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 528 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
367 doins "${mname}.patched" 529 doins "${mname}.patched"
368 530
369 fi 531 fi
370 532
533
534
371 cd "${S}" 535 cd "${S}"
372 insinto "${VDR_PLUGIN_DIR}" 536 insinto "${VDR_PLUGIN_DIR}"
373 doins libvdr-*.so.* 537 doins libvdr-*.so.*
374 538
375 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 539 # create list of all created plugin libs
540 vdr_plugin_list=""
541 local p_name
542 for p in libvdr-*.so.*; do
543 p_name="${p%.so*}"
544 p_name="${p_name#lib}"
545 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
546 done
547
548 create_header_checksum_file ${vdr_plugin_list}
549 create_plugindb_file ${vdr_plugin_list}
550
551 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
376 einfo "Installing locales" 552 einfo "Installing locales"
377 cd "${TMP_LOCALE_DIR}" 553 cd "${TMP_LOCALE_DIR}"
378 insinto "${LOCDIR}" 554 insinto "${LOCDIR}"
379 doins -r * 555 doins -r *
380 fi 556 fi
398 574
399 if [[ -n ${VDR_RCADDON_FILE} ]]; then 575 if [[ -n ${VDR_RCADDON_FILE} ]]; then
400 insinto "${VDR_RC_DIR}" 576 insinto "${VDR_RC_DIR}"
401 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 577 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
402 fi 578 fi
403
404 create_header_checksum_file
405 create_plugindb_file
406}
407
408vdr-plugin_print_enable_command() {
409 ewarn "emerge --config ${PN} is deprecated"
410 elog
411 elog "To activate this vdr-plugin execute the following command:"
412 elog "\teselect vdr-plugin enable ${PN#vdr-}"
413 elog
414} 579}
415 580
416vdr-plugin_pkg_postinst() { 581vdr-plugin_pkg_postinst() {
417 vdr-plugin_print_enable_command 582 vdr-plugin_print_enable_command
418 583
425 590
426vdr-plugin_pkg_postrm() { 591vdr-plugin_pkg_postrm() {
427 delete_orphan_plugindb_file 592 delete_orphan_plugindb_file
428} 593}
429 594
430vdr-plugin_pkg_config_legacy() {
431 elog "Using old interface to gentoo-vdr-scripts-0.3.7"
432 if [[ -z "${INSTALLPLUGIN}" ]]; then
433 INSTALLPLUGIN="${VDRPLUGIN}"
434 fi
435
436 active=0
437 # First test if plugin is already inside PLUGINS
438 local conf=/etc/conf.d/vdr.plugins
439 exec 3<${conf}
440 while read -u 3 line; do
441 [[ ${line} == "" ]] && continue
442 [[ ${line:0:1} == "#" ]] && continue
443 set -- ${line}
444 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
445 done
446 exec 3<&-
447
448 if [[ $active == 0 ]]; then
449 elog "Adding ${INSTALLPLUGIN} to active plugins."
450
451 # The pure edit process.
452 echo "${INSTALLPLUGIN}" >> "${conf}"
453 else
454 elog "${INSTALLPLUGIN} already activated"
455 echo
456 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
457 if [[ "${answer}" != "yes" ]]; then
458 elog "aborted"
459 return
460 fi
461 elog "Removing ${INSTALLPLUGIN} from active plugins."
462
463 # The pure edit process
464 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
465 fi
466}
467
468vdr-plugin_pkg_config() { 595vdr-plugin_pkg_config() {
596 ewarn "emerge --config ${PN} is no longer supported"
469 vdr-plugin_print_enable_command 597 vdr-plugin_print_enable_command
470
471 einfo "Calling this now"
472 eselect vdr-plugin enable "${PN#vdr-}"
473} 598}
474 599
475fix_vdr_libsi_include() 600case "${EAPI:-0}" in
476{ 601 2)
477 einfo "Fixing include of libsi-headers" 602 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
478 local f 603 ;;
479 for f; do 604 *)
480 sed -i "${f}" \
481 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
482 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
483 done
484}
485
486EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 605 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
606 ;;
607esac

Legend:
Removed from v.1.50  
changed lines
  Added in v.1.69

  ViewVC Help
Powered by ViewVC 1.1.20